// dolbears law
// cricket chirps / minute indicate temperature


// init
(
Server.default = s = Server.local;
s.boot;
g = SwingOSC.default;
g.boot;
)

// der grillen synth
(
SynthDef(\cricket, {
	|amp(0.1), fmfreq(1.0), fmindex(1.0), fmoffset(0), amfreq(1), gate(1), pfreq(0.1)|
	var  sig = SinOsc.ar(
		SinOsc.ar(fmfreq, 0, fmindex, fmoffset), // frequenz modulation des basistons, zirpeffekt
		0, // phase
		SinOsc.kr( // AM, die zirp-pulse
			amfreq,
			//WhiteNoise.ar(0.1, amfreq), // 
			0.0,
			Linen.kr(gate, 0.5, 1.0, 2.5, doneAction: 2).squared * amp
		)
	);
	//Out.ar(0, Pan2.ar(sig, LFNoise0.ar(pfreq)));
	Out.ar(0, Pan2.ar(sig, 0));
}).send(s);
)

// test
x = Synth(\cricket, [\amp, 0.1, \fmfreq, rrand(40, 80), \fmindex, 1000, \fmoffset, 10000, \amfreq, 1, \gate, 1]);
x.set(\amp, 0.5);
x.set(\fmindex, 600);
x.set(\fmfreq, 200);
x.set(\gate, 0);

(
~cricket1 = Synth(\cricket, [\amp, 0.1, \fmfreq, rrand(40, 80), \fmindex, rrand(900, 1100), \fmoffset, 10000, \amfreq, 1, \gate, 1, \pfreq, rrand(0.01, 0.1)]);
//~cricket2 = Synth(\cricket, [\amp, 0.1, \fmfreq, rrand(40, 80), \fmindex, rrand(900, 1100), \fmoffset, 10000, \amfreq, 1, \gate, 1, \pfreq, rrand(0.01, 0.1)]);
//~cricket3 = Synth(\cricket, [\amp, 0.1, \fmfreq, rrand(40, 80), \fmindex, rrand(900, 1100), \fmoffset, 10000, \amfreq, 1, \gate, 1, \pfreq, rrand(0.01, 0.1)]);
~resp = OSCresponder(nil, "/temperature", {
	|t,r,m|
	(m[2].ctofh - 40 / 15).postln;
	~cricket1.set(\amfreq, m[2].ctofh - 40 / 15);
	//	~cricket2.set(\amfreq, m[2].ctofh - 40 / 15);
	//	~cricket3.set(\amfreq, m[2].ctofh - 40 / 15);
});
~resp.add;
)

~cricket1.set(\gate, 0);
~resp.remove;

{s.freeAll; ~resp.remove;}.defer(2)

// some testing
23.ctofh
32.fhtoc
Number.browse
